#include <iostream.h>
#include <winsock2.h>
#include <ws2tcpip.h>
#include <stdio.h>
#include <mrt.h>


sys_kernel_read_rt_table (void) {


}

sys_kernel_update_route (prefix_t * dest, prefix_t * nexthop, 
                         prefix_t * oldhop, int index, int oldindex) {

}


int read_interfaces () {
    INTERFACE_INFO InterfaceList[20];
	unsigned long nBytesReturned;
	int nNumInterfaces, i;
	u_long nFlags;
	struct sockaddr_in *pAddress, *pAddress_Mask, *pAddress_BroadCast;
	WSADATA WinsockData;
	SOCKET sd;
	interface_t *interfce;
	char *name;

	if (WSAStartup(MAKEWORD(2, 2), &WinsockData) != 0) {
        printf ("Failed to find Winsock 2.2!\n"); 
        return 2;
    }


	sd = WSASocket(AF_INET, SOCK_DGRAM, 0, 0, 0, 0);

    if (sd == SOCKET_ERROR) {
        printf ("Failed to get a socket.  Error %d\n", WSAGetLastError());
        return 1;
    }
    

    if (WSAIoctl(sd, SIO_GET_INTERFACE_LIST, 0, 0, &InterfaceList,
            sizeof(InterfaceList), &nBytesReturned, 0, 0) == 
            SOCKET_ERROR) {
        LPVOID lpMsgBuf;
		printf ("Failed calling WSAIoctl: error %d\n", WSAGetLastError());
        
		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
			NULL,
			GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
		);

		return 1;
    }

    nNumInterfaces = nBytesReturned / sizeof(INTERFACE_INFO);
    //printf ("There are %d interfaces\n", nNumInterfaces);
    for (i = 0; i < nNumInterfaces; ++i) {
        printf ("\n");
        
        
        pAddress = (struct sockaddr_in*)&(InterfaceList[i].iiAddress);
		//printf ("    %s", inet_ntoa(pAddress->sin_addr));
		name = strdup (inet_ntoa(pAddress->sin_addr));

        pAddress_BroadCast = (struct sockaddr_in*)&(InterfaceList[i].iiBroadcastAddress);
        //printf (" has bcast %s", inet_ntoa(pAddress->sin_addr));

        pAddress_Mask = (struct sockaddr_in*)&(InterfaceList[i].iiNetmask);
        //printf (" and netmask %s\n", inet_ntoa(pAddress_BroadCast->sin_addr));

        printf ("    Iface is ");
        nFlags = InterfaceList[i].iiFlags;
        if (nFlags & IFF_UP) printf ("up");
        else printf ("down");
        if (nFlags & IFF_POINTTOPOINT) printf (", is point-to-point");
        if (nFlags & IFF_LOOPBACK) printf (", is a loopback iface");
        printf (", and can do: ");
        if (nFlags & IFF_BROADCAST) printf ("bcast ");
        if (nFlags & IFF_MULTICAST) printf ("multicast ");
        printf ("\n");

		interfce = new_interface (name, nFlags, 512, 0);
		add_addr_to_interface (interfce, AF_INET,
                           &pAddress->sin_addr.s_addr,
                           mask2len (&pAddress_Mask->sin_addr.s_addr, 4),
                           &pAddress->sin_addr.s_addr);

    }

    return 0;
}