#define _MT
//#undef __cplusplus

#include <mrt_win_NT.h>
#include <time.h>
#include "mrt_win_nt.h"
#include <mrt.h>
#include <trace.h>
#include <stdio.h>
#include <iostream.h>
#include <windows.h>

void Ktimer_callback(void)
{
	printf("timer fired!!\n");
}

void main(void)
{
	mtimer_t *Ktimer;
	trace_t *tr = NULL;
	schedule_t *sched;
	prefix_t *prefix;
	//int port = 6789;
	int sockfd = 5;
	char *port = "mrt";

	tr = New_Trace2 ("MRT-NT");
	set_trace (tr, TRACE_LOGFILE, "stdout", 
			TRACE_FLAGS, TR_ALL, 
			NULL);

	init_mrt(tr);
	//init_select(tr);

	sched = New_Schedule ("my_new_schedule", tr);
	//printf("here is result of nonblock_connect call %i\n\n", nonblock_connect (tr, prefix,  port, sockfd));
	
	prefix = string_toprefix("198.109.66.1", tr);
	
	printf("here is the conversion '%s'\n\n", prefix_toname(prefix));


	//Ktimer = New_Timer (Ktimer_callback, 1, "what", NULL);

	//Timer_Turn_ON(Ktimer);
	//mrt_select();
	//mrt_select_loop();


	doit();

	init_uii (tr);
    init_uii_port (port);
	init_rib (tr);

	init_BGP (tr);
	
	config_bgp_init ();
    //config_rtmap_init ();

	start_bgp ();


	listen_uii2 (NULL);


	mrt_main_loop();



	
}