/*
 * $Id: assert.h,v 1.1.1.1 1999/06/28 15:03:54 labovit Exp $
 */

//#if !defined(MRT_WIN_NT)
//#include <config.h>
//#else
//#include <config_file.h>
//#endif

#ifndef _ASSERT_H
#define _ASSERT_H
#include <string.h>
#include <mrt.h>
#include <trace.h>

#undef assert
#define assert(exp) \
    ((exp)?0: trace (FATAL, MRT->trace, \
        "MRT: assertion (%s) failed at line %d file %s\n",  \
	#exp, __LINE__, __FILE__))

#define perror(s) \
    trace (ERROR, MRT->trace, "MRT: %s: %s\n", s, strerror (errno));

#endif /* _ASSERT_H */
